"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendDotCjsDirect = void 0;
const typescript_1 = require("typescript");
const shouldMutateModuleSpecifier_cjs_1 = require("./shouldMutateModuleSpecifier.cjs");
function appendDotCjsDirect(program, transformationContext, debug) {
    function addCjsExtension(transformationContext) {
        function visitNode(node) {
            if ((0, shouldMutateModuleSpecifier_cjs_1.shouldMutateModuleSpecifier)(node.getSourceFile().fileName, node, debug, program)) {
                const moduleSpecifier = transformationContext.factory.createStringLiteral(`${node.moduleSpecifier.text}.cjs`);
                Object.assign(moduleSpecifier, { parent: node });
                Object.assign(node, { moduleSpecifier });
            }
            return node;
        }
        return (sourceFile) => {
            return (0, typescript_1.visitEachChild)(sourceFile, visitNode, transformationContext);
        };
    }
    // https://github.com/Jack-Works/commonjs-import.meta/blob/master/index.ts
    function updateMetaRequest(transformationContext) {
        // @ts-ignore
        const { factory: ts } = transformationContext;
        function visitNode(node) {
            if ((0, typescript_1.isPropertyAccessExpression)(node) &&
                (0, typescript_1.isMetaProperty)(node.expression) &&
                (0, typescript_1.idText)(node.expression.name) === 'meta' &&
                (0, typescript_1.idText)(node.name) === 'url') {
                return ts.createParenthesizedExpression(ts.createBinaryExpression(ts.createStringLiteral('file://'), typescript_1.SyntaxKind.PlusToken, ts.createIdentifier('__filename')));
            }
            else {
                return (0, typescript_1.visitEachChild)(node, visitNode, transformationContext);
            }
        }
        return (sourceFile) => {
            return (0, typescript_1.visitEachChild)(sourceFile, visitNode, transformationContext);
        };
    }
    const a = addCjsExtension(transformationContext);
    const b = updateMetaRequest(transformationContext);
    return (sourceFile) => {
        return b(a(sourceFile));
    };
}
exports.appendDotCjsDirect = appendDotCjsDirect;
//# sourceMappingURL=append.cjs.heft.js.map