"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendDotJs = void 0;
const typescript_1 = require("typescript");
const shouldMutateModuleSpecifier_cjs_1 = require("./shouldMutateModuleSpecifier.cjs");
function appendDotJs(program, transformationContext, console) {
    function visitNode(node) {
        if ((0, shouldMutateModuleSpecifier_cjs_1.shouldMutateModuleSpecifier)(node.getSourceFile().fileName, node, console, program)) {
            console.debug(' * %s', node.getText(node.getSourceFile()).split('\n')[0]);
            const modified = Object.create(node);
            const moduleSpecifier = transformationContext.factory.createStringLiteral(`${node.moduleSpecifier.text}.js`);
            Object.assign(moduleSpecifier, { parent: node });
            Object.assign(modified, { moduleSpecifier });
            return modified;
        }
        else if (node.getText(node.getSourceFile()).startsWith('import ')) {
            console.debug(' ? %s', node.getText(node.getSourceFile()).split('\n')[0]);
        }
        return node;
    }
    return (sourceFile) => {
        console.debug('[trans] visit \x1B[2m%s\x1B[0m', sourceFile.fileName);
        const result = (0, typescript_1.visitEachChild)(sourceFile, visitNode, transformationContext);
        console.debug('[trans] visit complete');
        return result;
    };
}
exports.appendDotJs = appendDotJs;
//# sourceMappingURL=append.js.js.map